/******************************************************/
/**  Dummy Time() procedure so that Dhrystone works  **/
/**  This only works if program run time is < 65 sec **/
/******************************************************/
#ifdef MCF5307
  #include "sim5307.h"

  static volatile SIM5307 *sim = (SIM5307 *)0x10000000;
#else
  #include "sim5206.h"

  static volatile SIM5206 *sim = (SIM5206 *)0x10000000;
#endif


long time()
{
#if defined(MCF5307)
  return (sim->timer1.tcn * 1000) / 11250; /* 45MHz bus speed */
#elif defined(MCF5206e)
  return (sim->timer1.tcn * 1000) / 13500; /* 54MHz bus speed */
#else
  return (sim->timer1.tcn * 1000) / 6250; /* 25MHz bus speed */
#endif
}


void Init_Timer( void )
{
  /* Enable the ColdFire cache */
#ifndef MCF5307
  __asm__ __volatile__(" nop
        move.l  #0x80000000,%d0
        movec   %d0,%cacr
	nop ");
#else
  __asm__ __volatile__(" nop
        move.l  #0x81000300,%d0
        movec   %d0,%cacr
	nop 
	move.l  #0x0000C000,%d0
        movec   %d0,%acr0
        nop ");

#endif


  /* Reset timer1 */
  sim->timer1.tmr = MCF5XXX_TIMER_TMR_RST;    
  sim->timer1.tmr = MCF5XXX_TIMER_TMR_CLK_STOP;   
  sim->timer1.tmr = MCF5XXX_TIMER_TMR_RST;    
  sim->timer1.tcn = 0; /* zero count */
  sim->timer1.ter = MCF5XXX_TIMER_TER_REF | MCF5XXX_TIMER_TER_CAP; /* clear pending */

  /* Setup Timer */
  sim->timer1.tmr = MCF5XXX_TIMER_TMR_PS( 250 )  |
                    MCF5XXX_TIMER_TMR_CE_NONE    |
                    MCF5XXX_TIMER_TMR_FRR        |
                    MCF5XXX_TIMER_TMR_CLK_DIV16  |
                    MCF5XXX_TIMER_TMR_RST;
}




