#ifndef MCF5307
  #error "You can only run siminfo2 on a MCF5307"
#endif

#include <stdio.h>

#include "sim5307.h"

int main()
{
  SIM5307 *sim = (SIM5307 *)0x10000000;
  int     index;

  iprintf("System Integration Module Info Program\n");
  iprintf("Copyright (c) 1997-1998 - David Fiddes, D.J.Fiddes@hw.ac.uk\n\n");

  iprintf("Set sim pointer: sim =%#X\n\n",sim);

  iprintf("Module: SIM - System Integration Module Configuration\n");
  iprintf("  RSR:    %.2X\n",sim->rsr);
  iprintf("  SYPCR:  %.2X\n",sim->sypcr);
  iprintf("  SWIVR:  %.2X\n",sim->swivr);
  iprintf("  SWSR:   %.2X\n",sim->swsr);
  iprintf("  PAR:    %.4X\n",sim->par);
  iprintf("  IRQPAR: %.2X\n",sim->irqpar);
  iprintf("  PLLCR:  %.2X\n",sim->pllcr);
  iprintf("  MPARK:  %.2X\n",sim->mpark);
  iprintf("  IPR:    %.8X\n",sim->ipr);
  iprintf("  IMR:    %.8X\n",sim->imr);
  iprintf("  AVCR:   %.2X\n",sim->avcr);
  iprintf("  ICR0:   %.2X\n",sim->icr0);
  iprintf("  ICR1:   %.2X\n",sim->icr1);
  iprintf("  ICR2:   %.2X\n",sim->icr2);
  iprintf("  ICR3:   %.2X\n",sim->icr3);
  iprintf("  ICR4:   %.2X\n",sim->icr4);
  iprintf("  ICR5:   %.2X\n",sim->icr5);
  iprintf("  ICR6:   %.2X\n",sim->icr6);
  iprintf("  ICR7:   %.2X\n",sim->icr7);
  iprintf("  ICR8:   %.2X\n",sim->icr8);
  iprintf("  ICR9:   %.2X\n",sim->icr9);
  iprintf("  ICR10:  %.2X\n",sim->icr10);
  iprintf("  ICR11:  %.2X\n",sim->icr11);

  iprintf("\n");

  iprintf("Module: CS - Chip Select configuration\n");
  for(index=0; (index<2); index++)
  {
    iprintf("  CSAR%d:  %.4X\n",index,sim->cs_abs[index].csar);
    iprintf("  CSMR%d:  %.8X\n",index,sim->cs_abs[index].csmr);
    iprintf("  CSCR%d:  %.4X\n",index,sim->cs_abs[index].cscr);
  }
  
  iprintf("  CSBAR:  %.2X\n",sim->csbar);

  for(index=2; (index<8); index++)
  {
    iprintf("  CSMR%d:  %.8X\n",index,sim->cs_rel[index-2].csmr);
    iprintf("  CSCR%d:  %.4X\n",index,sim->cs_rel[index-2].cscr);
  }

  iprintf("\n");

  iprintf("Module: DRAMC - DRAM controller configuration\n");
  iprintf("  DCR:    %.4X\n",sim->dcr);
  iprintf("  DACR0:  %.8X\n",sim->dacr0);
  iprintf("  DMR0:   %.8X\n",sim->dmr0);
  iprintf("  DACR1:  %.8X\n",sim->dacr1);
  iprintf("  DMR1:   %.8X\n",sim->dmr1);
  
  iprintf("\n");


  iprintf("Module: GPIO - General Purpose IO\n");
  iprintf("  PADDR:  %.4X\n",sim->paddr);
  iprintf("  PADAT:  %.4X\n",sim->padat);

  iprintf("\n");

  iprintf("Additional Module Offsets\n");
  iprintf("  timer1 = %#X\n",(int)&sim->timer1);
  iprintf("  timer2 = %#X\n",(int)&sim->timer2);
  iprintf("  uart1  = %#X\n",(int)&sim->uart1);
  iprintf("  uart2  = %#X\n",(int)&sim->uart2);
  iprintf("  mbus   = %#X\n",(int)&sim->mbus);
  for(index=0; (index<4); index++)
  {
    iprintf("  dma[%d]:  %#X\n",index,(int)&sim->dma[index]);
  }

                      
  iprintf("\n\nThe End.\n");
  return 0;
}
